# Review: https://bugzilla.redhat.com/show_bug.cgi?id=567257

# Upstream git:
# git://pcmanfm.git.sourceforge.net/gitroot/pcmanfm/libfm
# add bootstrap, need to build menu-cache in epel7
%global         userelease  1
%global         usegit      0
%global         usegitbare  0

%if 0%{?usegit} < 1
%if 0%{?usegitbare} < 1
# force
%global         userelease  1
%endif
%endif

%global         bootstrap   0
%global         mainver     1.3.1
%undefine       prever
%global         prerpmver    %(echo "%{?prever}" | sed -e 's|-||g')

%global         mainrel     1

%if 0%{?usegit} >= 1
%global         githash     ab583d7800bbc308f2852384f87c2357f49b01cd
%global         shorthash   %(TMP=%githash ; echo ${TMP:0:10})
%global         gitdate     Fri, 9 Dec 2016 01:44:54 +0200
%global         gitdate_num 20161209
%endif

%if 0%{?usegitbare} >= 1
%global         gitbaredate 20171230
%global         gitbaretime 1949
%endif

%if 0%{?userelease} >= 1
%global         fedorarel   %{?prever:0.}%{mainrel}%{?prever:.%{prerpmver}}
%endif
%if 0%{?usegit} >= 1
%global         fedorarel   %{mainrel}.D%{gitdate_num}git%{shorthash}
%endif
%if 0%{?usegitbare} >= 1
%global         fedorarel   %{mainrel}.gitD%{gitbaredate}
%endif

%global         build_doc   1

%undefine        _changelog_trimtime

Name:           libfm 
Version:        %{mainver}
Release:        %{fedorarel}%{?dist}.3
Summary:        GIO-based library for file manager-like programs

License:        GPLv2+
URL:            http://pcmanfm.sourceforge.net/
%if 0%{?userelease} >= 1
Source0:        http://downloads.sourceforge.net/pcmanfm/%{name}-%{mainver}%{?prever}.tar.xz
Source1:        https://raw.githubusercontent.com/lxde/libfm/master/autogen.sh
%endif
%if 0%{?usegit} >= 1
Source0:        https://github.com/lxde/libfm/archive/%{githash}/%{name}-%{version}-D%{gitdate_num}git%{githash}.tar.gz
%endif
%if 0%{?usegitbare} >= 1
Source0:        libfm-%{gitbaredate}T%{gitbaretime}.tar.gz
%endif
Source10:       create-libfm-git-bare-tarball.sh

# http://sourceforge.net/p/pcmanfm/feature-requests/385/
#Patch1000:      http://sourceforge.net/p/pcmanfm/feature-requests/_discuss/thread/0a50a386/597e/attachment/libfm-1.2.3-moduledir-gtkspecific-v02.patch
Patch1000:      libfm-1.3.0.2-moduledir-gtkspecific-v03.patch

BuildRequires:  libexif-devel
BuildRequires:  gtk3-devel
%if 0%{?fedora} >= 22
BuildRequires:	gtk2-devel
%endif

%if ! 0%{?bootstrap}
BuildRequires:  menu-cache-devel >= 0.3.2
%endif

BuildRequires:  gettext
BuildRequires:  intltool
BuildRequires:  desktop-file-utils

BuildRequires:  gtk-doc
BuildRequires:  libxslt

BuildRequires:  dbus-glib-devel

BuildRequires:  vala

# Patch1000 needs the below anyway
BuildRequires:  automake
BuildRequires:  libtool

%if 0%{?usegitbare} >= 1
BuildRequires:  git
%endif

%if 0%{?build_doc} < 1
Obsoletes:      %{name}-devel-docs < 0.1.15
%endif


%description
LibFM is a GIO-based library used to develop file manager-like programs. It is
developed as the core of next generation PCManFM and takes care of all file-
related operations such as copy & paste, drag & drop, file associations or 
thumbnails support. By utilizing glib/gio and gvfs, libfm can access remote 
file systems supported by gvfs.

This package contains the generic non-gui functions of libfm.


%package        gtk
Summary:        File manager-related GTK+ widgets of %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       gvfs

%description    gtk
libfm is a GIO-based library used to develop file manager-like programs. It is
developed as the core of next generation PCManFM and takes care of all file-
related operations such as copy & paste, drag & drop, file associations or 
thumbnail support. By utilizing glib/gio and gvfs, libfm can access remote 
file systems supported by gvfs.

This package provides useful file manager-related GTK+ 3 widgets.

%package        gtk2
Summary:        File manager-related GTK+ widgets of %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       gvfs

%description    gtk2
libfm is a GIO-based library used to develop file manager-like programs. It is
developed as the core of next generation PCManFM and takes care of all file-
related operations such as copy & paste, drag & drop, file associations or 
thumbnail support. By utilizing glib/gio and gvfs, libfm can access remote 
file systems supported by gvfs.

This package provides useful file manager-related GTK+ 2 widgets.

%package        gtk-utils
Summary:        GTK+ related utility package for %{name}
Requires:       %{name}-gtk%{?isa} = %{version}-%{release}
Obsoletes:      lxshortcut < 0.1.3
Provides:       lxshortcut = %{version}-%{release}
Provides:       lxshortcut%{?_isa} = %{version}-%{release}

%description    gtk-utils
This package contains some GTK+ related utility files for
%{name}.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%package        gtk-devel-common
Summary:        Common Development files for %{name}-gtk
Requires:       %{name}-devel = %{version}-%{release}
BuildArch:		noarch

%description    gtk-devel-common
The %{name}-gtk-devel package contains common header files for
developing applications that use %{name}-gtk.


%package        gtk-devel
Summary:        Development files for %{name}-gtk
Requires:       %{name}-gtk%{?_isa} = %{version}-%{release}
Requires:       %{name}-gtk-devel-common = %{version}-%{release}

%description    gtk-devel
The %{name}-gtk-devel package contains libraries files for
developing applications that use %{name}-gtk.

%package        gtk2-devel
Summary:        Development files for %{name}-gtk2
Requires:       %{name}-gtk2%{?_isa} = %{version}-%{release}
Requires:       %{name}-gtk-devel-common = %{version}-%{release}

%description    gtk2-devel
The %{name}-gtk2-devel package contains libraries files for
developing applications that use %{name}-gtk2.

%package        devel-docs
Summary:        Development documation for %{name}

%description    devel-docs
This package containg development documentation files for %{name}.


%prep
%if 0%{?userelease} >= 1
%setup -q -n %{name}-%{version}%{?prever}
cp -a %{SOURCE1} .
#%%patch0 -p1 -b .orig
%endif
%if 0%{?usegit} >= 1
%setup -q -n %{name}-%{githash}
%endif

%if 0%{?usegitbare} < 1
%endif

%if 0%{?usegitbare} >= 1
%setup -q -c -T -a 0
git clone ./libfm.git/
cd libfm
cp -a [A-Z]* ..

git config user.name "libfm Fedora maintainer"
git config user.email "libfm-maintainer@fedoraproject.org"

git checkout -b %{version}-fedora %{version}
cat > GITHASH <<EOF
EOF

cat GITHASH | while read line
do
  commit=$(echo "$line" | sed -e 's|[ \t].*||')
  git cherry-pick $commit
done
%endif

%if 0%{?fedora} >= 22
%patch1000 -p1
%endif
%if 0%{?usegitbare} >= 1
git commit -m "Use gtk version specific module directory" -a
%endif

# Patch1000 needs below anyway
sh autogen.sh

# treak rpath
sed -i.libdir_syssearch \
  -e '/sys_lib_dlsearch_path_spec/s|/usr/lib |/usr/lib /usr/lib64 /lib /lib64 |' \
  configure

%build
%if 0%{?usegitbare} >= 1
cd libfm
%endif

%if (0%{?usegitbare} >= 1) || (0%{?usegit} >= 1)
# Workaround
# Once generate files anyway
./configure
make dist
rm -f config.status
%endif

for ver in \
%if 0%{?fedora} >= 22
	2 \
%endif
	3 \
	%{nil}
do
	rm -rf _BUILDDIR_gtk${ver}
	mkdir _BUILDDIR_gtk${ver}
	pushd _BUILDDIR_gtk${ver}
	ln -sf ../configure

	%configure \
	    --srcdir=$(pwd)/.. \
%if 0%{?bootstrap}
	    --with-extra-only \
%endif
	    --enable-gtk-doc \
	    --enable-udisks \
	    --with-gtk=${ver} \
%if 0
	    --enable-demo \
%endif
	    --disable-silent-rules \
	    --disable-static

	# To show translation status
	make -C po -j1 GMSGFMT="msgfmt --statistics"
	make %{?_smp_mflags} -k

	make install DESTDIR=$(pwd)/../INSTDIR-gtk${ver}
	popd
done

%install
TOPDIR=$(pwd)

%if 0%{?usegitbare} >= 1
cd libfm
%endif

# GTK3
cp -a INSTDIR-gtk3/* $RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/libfm-gtk.pc

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
%if ! 0%{?bootstrap}
desktop-file-validate %{buildroot}/%{_datadir}/applications/*.desktop
( 
cd $TOPDIR
%find_lang %{name}
)
%endif

echo '%%defattr(-,root,root,-)' > $TOPDIR/base-header.files
echo '%%defattr(-,root,root,-)' > $TOPDIR/gtk-header.files

for f in $RPM_BUILD_ROOT%_includedir/%name-1.0/*.h
do
  bf=$(basename $f)
  for dir in actions base job extra .
  do
    if [ -f src/$dir/$bf ]
    then
	echo %_includedir/%name-1.0/$bf >> $TOPDIR/base-header.files
    fi
  done
  for dir in gtk
  do
    if [ -f src/$dir/$bf ]
    then
	echo %_includedir/%name-1.0/$bf >> $TOPDIR/gtk-header.files
    fi
  done
done

# GTK2
%if ! 0%{?bootstrap}
%if 0%{?fedora} >= 22
pushd INSTDIR-gtk2

find . -name '*.la' -exec rm -f {} ';'
rm -f .{_libdir}/pkgconfig/libfm-gtk3.pc

diff -urNp .%{_includedir}/%{name}-1.0 $RPM_BUILD_ROOT%{_includedir}/%name-1.0
diff -urNp .%{_datadir}/%{name} $RPM_BUILD_ROOT/%{_datadir}/%{name}

cp -a ./%{_libdir}/libfm-gtk* $RPM_BUILD_ROOT%{_libdir}
cp -a ./%{_libdir}/pkgconfig/libfm-gtk.pc \
	$RPM_BUILD_ROOT%{_libdir}/pkgconfig/
cp -a ./%{_libdir}/libfm/modules/gtk/ \
	$RPM_BUILD_ROOT%{_libdir}/libfm/modules/
popd
%endif
%endif

/usr/lib/rpm/check-rpaths

%check
%if 0%{?usegitbare} >= 1
cd libfm
%endif

find INSTDIR-gtk* -name \*.ui >> po/POTFILES.skip
for ver in \
%if 0%{?fedora} >= 22
	2 \
%endif
	3 \
	%{nil}
do
	pushd _BUILDDIR_gtk${ver}
	make check
	popd
done

%pre devel
# Directory -> symlink
if [ -d %{_includedir}/libfm ] ; then
  rm -rf %{_includedir}/libfm
fi

%if 0%{?bootstrap}
%files
%else
%files -f %{name}.lang
%endif
# FIXME: Add ChangeLog if not empty
%doc AUTHORS
%doc COPYING
%doc NEWS
%doc README
%if ! 0%{?bootstrap}
%dir %{_sysconfdir}/xdg/libfm/
%config(noreplace) %{_sysconfdir}/xdg/libfm/libfm.conf
%{_datadir}/%{name}/
%{_libdir}/%{name}.so.4*
%dir %{_libdir}/libfm
%dir %{_libdir}/libfm/modules
%{_libdir}/libfm/modules/vfs-*.so
%{_datadir}/mime/packages/libfm.xml
%endif
%{_libdir}/%{name}-extra.so.4*

%if ! 0%{?bootstrap}
%files gtk
%{_libdir}/%{name}-gtk3.so.4*
%if 0%{?fedora} < 22
%{_libdir}/libfm/modules/gtk-*.so
%else
%{_libdir}/libfm/modules/gtk3/
%endif

%files gtk-utils
%{_mandir}/man1/libfm-pref-apps.1.*
%{_mandir}/man1/lxshortcut.1.*
%{_bindir}/libfm-pref-apps
%{_bindir}/lxshortcut
%{_datadir}/applications/libfm-pref-apps.desktop
%{_datadir}/applications/lxshortcut.desktop
%endif

%files devel -f base-header.files
%doc TODO
%{_includedir}/libfm
%dir %{_includedir}/libfm-1.0/
%if ! 0%{?bootstrap}
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/libfm.pc
%endif
%{_libdir}/%{name}-extra.so
%{_libdir}/pkgconfig/libfm-extra.pc

%if ! 0%{?bootstrap}
%files gtk-devel-common -f gtk-header.files
%{_includedir}/libfm-1.0/fm-gtk.h

%files gtk-devel
%{_libdir}/%{name}-gtk3.so
%{_libdir}/pkgconfig/libfm-gtk3.pc

%if 0%{?fedora} >= 22
%files gtk2
%{_libdir}/%{name}-gtk.so.4*
%{_libdir}/libfm/modules/gtk/

%files gtk2-devel
%{_libdir}/%{name}-gtk.so
%{_libdir}/pkgconfig/libfm-gtk.pc
%endif

%if 0%{?build_doc}
%files devel-docs
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%{_datadir}/gtk-doc/html/%{name}
%endif
%endif

%changelog
* Fri Dec 16 2022 NewStart <os@gd-linux.com> - 1.3.1-3
- replace 'bootstrap 1' to 'bootstrap 0'

* Fri Dec 16 2022 NewStart <os@gd-linux.com> - 1.3.1-2
- First release.
